## uthash 1.8

=== doc/Makefile ===
all: css userguide changelog pdf utlist

userguide:	txt/userguide.txt
	asciidoc --unsafe --out-file=html/userguide.html -a linkcss=1 -a theme=tdh $<

utlist: txt/utlist.txt
	asciidoc --unsafe --out-file=html/utlist.html -a linkcss=1 -a theme=tdh $<

changelog:	txt/ChangeLog.txt
	asciidoc --out-file=html/ChangeLog.html txt/ChangeLog.txt 

.PHONY: pdf

pdf: txt/userguide.txt
	a2x --format=pdf $<
	mv txt/userguide.pdf pdf/
	cd html && ln -sf ../pdf/userguide.pdf userguide.pdf
	rm txt/userguide.xml

css: html/toc.css
	cat /etc/asciidoc/stylesheets/xhtml11.css html/toc.css > html/tdh.css
	cp /etc/asciidoc/stylesheets/xhtml11-quirks.css html/tdh-quirks.css 

docbook: txt/userguide.txt
	asciidoc -b docbook --out-file=/tmp/userguide.xml $<
	xmlto -o html html-nochunks /tmp/userguide.xml

=== tests/Makefile ===
HASHDIR = ../src
FUNCS = BER SAX FNV OAT JEN SFH 
SPECIAL_FUNCS = MUR
UTILS = emit_keys
PROGS = test1 test2 test3 test4 test5 test6 test7 test8 test9   \
		    test10 test11 test12 test13 test14 test15 test16 test17 \
        test18 test19 test20 test21 test22 test23 test24 test25 \
        test26 test27 test28 test29 test30 test31 test32 test33 \
        test34 test35 test36 test37 test38 test39 test40
CFLAGS = -I$(HASHDIR) 
#CFLAGS += -DHASH_BLOOM=16
#CFLAGS += -O3
CFLAGS += -g
#CFLAGS += -Wstrict-aliasing=2
CFLAGS += -Wall 
#CFLAGS += -std=c89
CFLAGS += ${EXTRA_CFLAGS}

ifeq ($(HASH_DEBUG),1)
CFLAGS += -DHASH_DEBUG=1
endif

ifeq ($(HASH_PEDANTIC),1)
CFLAGS += -pedantic 
endif

TEST_TARGET=run_tests
TESTS=./do_tests

MUR_CFLAGS = -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing
# On GNU we use -fno-strict-aliasing when using the Murmurhash
ifneq ($(strip $(shell $(CC) -v 2>&1 |egrep "gcc")),)
ifeq ($(HASH_FUNCTION),"HASH_MUR")
  CFLAGS += $(MUR_CFLAGS)
endif
endif

# Prefer 64-bit compilation on Mac OS X (not necessary, just faster)
ifneq ($(strip $(shell $(CC) -v 2>&1 |egrep "i[0-9]+-apple-darwin")),)
  CFLAGS += -m64
endif

# detect Cygwin
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "cygwin")),)
  TESTS=./do_tests.cygwin
endif

# detect MinGW
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "mingw")),)
  TEST_TARGET=run_tests_mingw
  TESTS=./do_tests.mingw
endif

#detect Linux (platform specific utilities)
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "linux")),)
  PLAT_UTILS = hashscan test_sleep
endif


all: $(PROGS) $(UTILS) $(PLAT_UTILS) $(FUNCS) $(SPECIAL_FUNCS) $(TEST_TARGET) 

tests_only: $(PROGS) $(TEST_TARGET)

debug:
	$(MAKE) all HASH_DEBUG=1

pedantic:
	$(MAKE) all HASH_PEDANTIC=1

cplusplus:
	CC=$(CXX) $(MAKE) all 

example: example.c $(HASHDIR)/uthash.h
	$(CC) $(CFLAGS) -o $@ $(@).c 

$(PROGS) $(UTILS) : $(HASHDIR)/uthash.h
	$(CC) $(CFLAGS) -o $@ $(@).c 

hashscan : $(HASHDIR)/uthash.h
	$(CC) $(CFLAGS) $(MUR_CFLAGS) -o $@ $(@).c 

test_sleep : $(HASHDIR)/uthash.h 
	$(CC) $(CFLAGS) -DHASH_BLOOM=16 -o $@ $(@).c 

$(FUNCS) : $(HASHDIR)/uthash.h
	$(CC) $(CFLAGS) -DHASH_FUNCTION=HASH_$@ -o keystat.$@ keystat.c 

$(SPECIAL_FUNCS) : $(HASHDIR)/uthash.h
	$(CC) $(CFLAGS) $(MUR_CFLAGS) -DHASH_FUNCTION=HASH_$@ -o keystat.$@ keystat.c 

run_tests: $(PROGS)
	perl $(TESTS)

run_tests_mingw: $(PROGS)
	/bin/sh do_tests.mingw

.PHONY: clean

clean:	
	rm -f $(UTILS) $(PLAT_UTILS) $(PROGS) test*.out keystat.??? example *.exe
	rm -rf *.dSYM

=== debian/changelog ===
uthash (1.8-3) unstable; urgency=low

  * Manual was not installed.

 -- Bastian Blywis <blywis@inf.fu-berlin.de>  Fri, 15 Jan 2010 16:56:12 +0100

uthash (1.8-2) unstable; urgency=low

  * Deleted unecessary files from documentation.
  * Added example files.
  * Wrote man page.

 -- Bastian Blywis <blywis@inf.fu-berlin.de>  Thu, 14 Jan 2010 15:57:34 +0100

uthash (1.8-1) unstable; urgency=low

  * Initial release. (Closes: #565271: ITP: uthash -- A hash table and linked 
  list for C structures)

 -- Bastian Blywis <blywis@inf.fu-berlin.de>  Mon, 14 Jan 2010 11:34:16 +0100

=== debian/control ===
Source: uthash
Section: devel
Priority: extra
Maintainer: Bastian Blywis <blywis@inf.fu-berlin.de>
Build-Depends: debhelper (>= 7), docbook-xsl, docbook-xml, xsltproc
Standards-Version: 3.8.3
Homepage: http://uthash.sourceforge.net

Package: uthash-dev
Architecture: all
Depends: ${misc:Depends}
Description: A hash table and linked list for C structures
 This package provides uthash and utlist, C preprocessor
 implementations of a hash table and a linked list. It is
 a dev package without a source or binary package as there
 are only header files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

install:
	dh_installdirs	
	dh_installdocs
	install -m644 src/uthash.h $(CURDIR)/debian/uthash-dev/usr/include/
	install -m644 src/utlist.h $(CURDIR)/debian/uthash-dev/usr/include/
	cp -R doc/html $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/html
	cp -R doc/pdf $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/pdf
	rm -f $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/html/*.svg
	cp doc/txt/ChangeLog.txt $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/changelog

build:
	xsltproc --nonet \
	--param make.year.ranges 1 \
	--param make.single.year.ranges 1 \
	--param man.charmap.use.subset 0 \
	-o debian/uthash-dev.3 \
	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	debian/manpage.xml

#	make $(CURDIR)/doc/Makefile

binary-arch:

binary-indep: install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installexamples
	dh_install
	dh_installman
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

clean:
	dh_clean

#%:
#	dh  $@

## uthash 1.9.4

=== doc/Makefile ===
--- 
+++ 
@@ -6,8 +6,25 @@
 utlist: txt/utlist.txt
 	asciidoc --unsafe --out-file=html/utlist.html -a linkcss=1 -a theme=tdh $<
 
+utarray: txt/utarray.txt
+	asciidoc --unsafe --out-file=html/utarray.html -a linkcss=1 -a theme=tdh $<
+
+utstring: txt/utstring.txt
+	asciidoc --unsafe --out-file=html/utstring.html -a linkcss=1 -a theme=tdh $<
+
 changelog:	txt/ChangeLog.txt
 	asciidoc --out-file=html/ChangeLog.html txt/ChangeLog.txt 
+
+stage:
+	cp html/userguide.html ${PAGEROOT}/uthash
+	cp html/userguide.pdf ${PAGEROOT}/uthash
+	cp html/utlist.html ${PAGEROOT}/uthash
+	cp html/utarray.html ${PAGEROOT}/uthash
+	cp html/utstring.html ${PAGEROOT}/uthash
+	cp html/ChangeLog.html ${PAGEROOT}/uthash
+	cp html/license.html ${PAGEROOT}/uthash
+	cp html/index.html ${PAGEROOT}/uthash
+	cp html/styles.css ${PAGEROOT}/uthash
 
 .PHONY: pdf
 
@@ -15,7 +32,7 @@
 	a2x --format=pdf $<
 	mv txt/userguide.pdf pdf/
 	cd html && ln -sf ../pdf/userguide.pdf userguide.pdf
-	rm txt/userguide.xml
+	rm -f txt/userguide.xml
 
 css: html/toc.css
 	cat /etc/asciidoc/stylesheets/xhtml11.css html/toc.css > html/tdh.css

=== tests/Makefile ===
--- 
+++ 
@@ -6,10 +6,13 @@
 		    test10 test11 test12 test13 test14 test15 test16 test17 \
         test18 test19 test20 test21 test22 test23 test24 test25 \
         test26 test27 test28 test29 test30 test31 test32 test33 \
-        test34 test35 test36 test37 test38 test39 test40
+        test34 test35 test36 test37 test38 test39 test40 test41 \
+        test42 test43 test44 test45 test46 test47 test48 test49 \
+				test50 test51 test52 test53 test54 test55 test56 test57 \
+        test58 test59 test60 test61 test62 test63 test64
 CFLAGS = -I$(HASHDIR) 
 #CFLAGS += -DHASH_BLOOM=16
-#CFLAGS += -O3
+#CFLAGS += -O2
 CFLAGS += -g
 #CFLAGS += -Wstrict-aliasing=2
 CFLAGS += -Wall 
@@ -53,7 +56,14 @@
 
 #detect Linux (platform specific utilities)
 ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "linux")),)
-  PLAT_UTILS = hashscan test_sleep
+  PLAT_UTILS = hashscan sleep_test
+endif
+
+#detect FreeBSD (platform specific utilities)
+ifeq ($(strip $(shell uname -s)), FreeBSD)
+  ifeq ($(shell if [ `sysctl -n kern.osreldate` -ge 0801000 ]; then echo "ok"; fi), ok)
+    PLAT_UTILS = hashscan sleep_test
+  endif
 endif
 
 
@@ -79,7 +89,7 @@
 hashscan : $(HASHDIR)/uthash.h
 	$(CC) $(CFLAGS) $(MUR_CFLAGS) -o $@ $(@).c 
 
-test_sleep : $(HASHDIR)/uthash.h 
+sleep_test : $(HASHDIR)/uthash.h 
 	$(CC) $(CFLAGS) -DHASH_BLOOM=16 -o $@ $(@).c 
 
 $(FUNCS) : $(HASHDIR)/uthash.h

=== debian/changelog ===
uthash (1.9.4-1) unstable; urgency=low

  * New upstream release.
  * Added example files from upstream.
  * Patched out bashisms in example build script. Closes: #581144 
  * Updated package description to reflect inclusion of utarray and utstring.
  * Updated years in copyright file.
  * Replaced maintainer email address with new address in all files.
  * Bumped Standards-Version to 3.9.2 without changes needed.
  * Switched to 3.0 (quilt).
  * Patched examples scripts (updated paths and fixed a "sh -n" error).
  * Changed license of the packaging to BSD (2 Clause) to match upstream.

 -- Bastian Blywis <blywis@zedat.fu-berlin.de>  Wed, 08 Jun 2011 09:12:25 +0200

=== debian/control ===
Source: uthash
Section: devel
Priority: extra
Maintainer: Bastian Blywis <blywis@zedat.fu-berlin.de>
Build-Depends: debhelper (>= 7), docbook-xsl, docbook-xml, xsltproc
Standards-Version: 3.9.2
Homepage: http://uthash.sourceforge.net

Package: uthash-dev
Architecture: all
Depends: ${misc:Depends}
Description: Hash table and linked list for C structures
 This package provides uthash and utlist, C preprocessor
 implementations of a hash table and a linked list. It is
 a dev package without a source or binary package as there
 are only header files. Since version 1.9 uthash includes
 also macros for dynamic arrays and strings.

=== debian/rules ===
--- 
+++ 
@@ -4,11 +4,13 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-install:
+install: 
 	dh_installdirs	
 	dh_installdocs
 	install -m644 src/uthash.h $(CURDIR)/debian/uthash-dev/usr/include/
 	install -m644 src/utlist.h $(CURDIR)/debian/uthash-dev/usr/include/
+	install -m644 src/utarray.h $(CURDIR)/debian/uthash-dev/usr/include/
+	install -m644 src/utstring.h $(CURDIR)/debian/uthash-dev/usr/include/
 	cp -R doc/html $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/html
 	cp -R doc/pdf $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/pdf
 	rm -f $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/html/*.svg
@@ -43,7 +45,7 @@
 
 binary: binary-indep binary-arch
 
-clean:
+clean: 
 	dh_clean
 
 #%:

=== debian/watch ===
version=3

http://sf.net/uthash/uthash-(.+)\.tar\.bz

## uthash 1.9.5

=== doc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-all: css userguide changelog pdf utlist
+all: css userguide changelog pdf utlist utstring utarray
 
 userguide:	txt/userguide.txt
 	asciidoc --unsafe --out-file=html/userguide.html -a linkcss=1 -a theme=tdh $<
@@ -35,8 +35,8 @@
 	rm -f txt/userguide.xml
 
 css: html/toc.css
-	cat /etc/asciidoc/stylesheets/xhtml11.css html/toc.css > html/tdh.css
-	cp /etc/asciidoc/stylesheets/xhtml11-quirks.css html/tdh-quirks.css 
+	if [ ! -d ~/.asciidoc/themes/tdh ]; then mkdir ~/.asciidoc/themes/tdh; fi
+	cp html/toc.css ~/.asciidoc/themes/tdh
 
 docbook: txt/userguide.txt
 	asciidoc -b docbook --out-file=/tmp/userguide.xml $<

=== tests/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
         test34 test35 test36 test37 test38 test39 test40 test41 \
         test42 test43 test44 test45 test46 test47 test48 test49 \
 				test50 test51 test52 test53 test54 test55 test56 test57 \
-        test58 test59 test60 test61 test62 test63 test64
+        test58 test59 test60 test61 test62 test63 test64 test65
 CFLAGS = -I$(HASHDIR) 
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2
@@ -36,11 +36,6 @@
 ifeq ($(HASH_FUNCTION),"HASH_MUR")
   CFLAGS += $(MUR_CFLAGS)
 endif
-endif
-
-# Prefer 64-bit compilation on Mac OS X (not necessary, just faster)
-ifneq ($(strip $(shell $(CC) -v 2>&1 |egrep "i[0-9]+-apple-darwin")),)
-  CFLAGS += -m64
 endif
 
 # detect Cygwin

=== debian/changelog ===
uthash (1.9.5-1) unstable; urgency=low

  * New upstream release. Closes: #661651
  * Updated year in copyright file.
  * Added build-arch and build-indep target to debian/rules to fix lintian 
    warning debian-rules-missing-recommended-target.
  * Added rebuilding of documentationi in upstream source. The number of 
    build-dependencies increased due to this change.
  * Building of debian/uthash-dev.3 in build-indep instead of build.

 -- Bastian Blywis <blywis@zedat.fu-berlin.de>  Thu, 01 Mar 2012 16:03:09 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: extra
 Maintainer: Bastian Blywis <blywis@zedat.fu-berlin.de>
-Build-Depends: debhelper (>= 7), docbook-xsl, docbook-xml, xsltproc
+Build-Depends: debhelper (>= 7), docbook-xsl, docbook-xml, xsltproc, asciidoc, dblatex, libxml2-utils
 Standards-Version: 3.9.2
 Homepage: http://uthash.sourceforge.net

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-install: 
-	dh_installdirs	
+install:
+	dh_installdirs
 	dh_installdocs
 	install -m644 src/uthash.h $(CURDIR)/debian/uthash-dev/usr/include/
 	install -m644 src/utlist.h $(CURDIR)/debian/uthash-dev/usr/include/
@@ -16,7 +16,11 @@
 	rm -f $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/html/*.svg
 	cp doc/txt/ChangeLog.txt $(CURDIR)/debian/uthash-dev/usr/share/doc/uthash-dev/changelog
 
-build:
+build: build-arch build-indep
+
+build-arch:
+
+build-indep:
 	xsltproc --nonet \
 	--param make.year.ranges 1 \
 	--param make.single.year.ranges 1 \
@@ -24,15 +28,14 @@
 	-o debian/uthash-dev.3 \
 	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	debian/manpage.xml
-
-#	make $(CURDIR)/doc/Makefile
+	make -C $(CURDIR)/doc
 
 binary-arch:
 
 binary-indep: install
 	dh_testdir
 	dh_testroot
-	dh_installchangelogs 
+	dh_installchangelogs
 	dh_installexamples
 	dh_install
 	dh_installman
@@ -45,7 +48,7 @@
 
 binary: binary-indep binary-arch
 
-clean: 
+clean:
 	dh_clean
 
 #%:

## uthash 1.9.7

=== doc/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 	rm -f txt/userguide.xml
 
 css: html/toc.css
-	if [ ! -d ~/.asciidoc/themes/tdh ]; then mkdir ~/.asciidoc/themes/tdh; fi
+	if [ ! -d ~/.asciidoc/themes/tdh ]; then mkdir -p ~/.asciidoc/themes/tdh; fi
 	cp html/toc.css ~/.asciidoc/themes/tdh
 
 docbook: txt/userguide.txt

=== tests/Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+#CC=clang
 HASHDIR = ../src
 FUNCS = BER SAX FNV OAT JEN SFH 
 SPECIAL_FUNCS = MUR
@@ -9,7 +10,9 @@
         test34 test35 test36 test37 test38 test39 test40 test41 \
         test42 test43 test44 test45 test46 test47 test48 test49 \
 				test50 test51 test52 test53 test54 test55 test56 test57 \
-        test58 test59 test60 test61 test62 test63 test64 test65
+        test58 test59 test60 test61 test62 test63 test64 test65 \
+        test66 test67 test68 test69 test70 test71 test72 test73 \
+        test74 test75 test76 test77 test78
 CFLAGS = -I$(HASHDIR) 
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2

=== debian/changelog ===
uthash (1.9.7-1) unstable; urgency=low

  * New upstream release. Closes: #691924
  * Fixed watch file URL.
  * Updated patch build-doc as change has been incorporated into upstream.
  * Added brief description to build-doc patch.
  * Updated patch examples because upstream added a line.
  * Changed debian/rules to short format.
  * Raised required version of debhelper because of overwrites in debian/rules.
  * Bumped Standards-Version to 3.9.4 without changes needed.
  * Moved manual installation from debian/rules to uthash-dev.install*.
  * Renamed patches/build-doc to patches/build-doc.diff.
  * Replaced maintainer email address with new address in all files.

 -- Bastian Blywis <blywis@googlemail.com>  Sun, 20 Nov 2012 12:03:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: uthash
 Section: devel
 Priority: extra
-Maintainer: Bastian Blywis <blywis@zedat.fu-berlin.de>
-Build-Depends: debhelper (>= 7), docbook-xsl, docbook-xml, xsltproc, asciidoc, dblatex, libxml2-utils
-Standards-Version: 3.9.2
+Maintainer: Bastian Blywis <blywis@googlemail.com>
+Build-Depends: debhelper (>= 7.0.50~), docbook-xsl, docbook-xml, xsltproc, asciidoc, dblatex, libxml2-utils
+Standards-Version: 3.9.4
 Homepage: http://uthash.sourceforge.net
 
 Package: uthash-dev

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_installchangelogs:
	dh_installchangelogs doc/txt/ChangeLog.txt

override_dh_auto_build:
	xsltproc --nonet \
	--param make.year.ranges 1 \
	--param make.single.year.ranges 1 \
	--param man.charmap.use.subset 0 \
	-o debian/uthash-dev.3 \
	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	debian/manpage.xml
	make -C $(CURDIR)/doc

%:
	dh $@

=== debian/watch ===
version=3

http://sf.net/uthash/uthash-(.+)\.tar\.bz2

## uthash 1.9.9.1%2Bgit20151125

=== debian/control ===
Source: uthash
Section: devel
Priority: optional
Maintainer: Ilias Tsitsimpis <i.tsitsimpis@gmail.com>
Build-Depends: dh-exec (>=0.3), debhelper (>= 9), asciidoc
Standards-Version: 3.9.6
Vcs-Browser: https://bitbucket.org/iliastsi/uthash
Vcs-Git: https://bitbucket.org/iliastsi/uthash.git
Homepage: https://troydhanson.github.io/uthash/

Package: uthash-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: hash table and linked list for C structures
 uthash-dev provides a hash table implementation using C preprocessor macros.
 This package also includes:
  * utlist.h provides linked list macros for C structures
  * utarray.h implements dynamic arrays using macros
  * utstring.h implements a basic dynamic string

## uthash 1.9.9.1+git20150507

=== tests/Makefile ===
--- 
+++ 
@@ -12,13 +12,15 @@
 				test50 test51 test52 test53 test54 test55 test56 test57 \
         test58 test59 test60 test61 test62 test63 test64 test65 \
         test66 test67 test68 test69 test70 test71 test72 test73 \
-        test74 test75 test76 test77 test78
+        test74 test75 test76 test77 test78 test79 test80 test81 \
+        test82 test83 test84 test85
 CFLAGS = -I$(HASHDIR) 
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2
 CFLAGS += -g
 #CFLAGS += -Wstrict-aliasing=2
 CFLAGS += -Wall 
+#CFLAGS += -Wextra 
 #CFLAGS += -std=c89
 CFLAGS += ${EXTRA_CFLAGS}
 
@@ -102,7 +104,10 @@
 run_tests_mingw: $(PROGS)
 	/bin/sh do_tests.mingw
 
-.PHONY: clean
+astyle:
+	astyle -n --style=kr --indent-switches --add-brackets *.c
+
+.PHONY: clean astyle
 
 clean:	
 	rm -f $(UTILS) $(PLAT_UTILS) $(PROGS) test*.out keystat.??? example *.exe

=== opt/bundle/Makefile ===
SUBDIRS=src tests
all: $(SUBDIRS)

.PHONY: clean $(SUBDIRS)

$(SUBDIRS):
	for d in $(SUBDIRS); do $(MAKE) -C $$d; done

clean:
	rm -f $(OBJS) *.o
	for d in $(SUBDIRS); do $(MAKE) -C $$d $@; done

=== opt/bundle/tests/Makefile ===
PROGS=test1 test2 test3 test4 test5 test6 test7 test8 test9 test10 test11 test12 \
      test13 test14 test15
OBJS=$(patsubst %,%.o,$(PROGS))

CFLAGS = -I../include
CFLAGS += -g
CFLAGS += -Wall -Wextra
LDFLAGS=-lut -L../src

TEST_TARGET=run_tests
TESTS=./do_tests

all: $(OBJS) $(PROGS) $(TEST_TARGET) 

# static pattern rule: multiple targets 

$(OBJS): %.o: %.c
	$(CC) -c $(CFLAGS) $< 

$(PROGS): %: %.o
	$(CC) -o $@ $(CFLAGS) $< $(LDFLAGS)


run_tests: $(PROGS)
	perl $(TESTS)

.PHONY: clean

clean:	
	rm -f $(PROGS) $(OBJS) test*.out

=== debian/changelog ===
uthash (1.9.9.1+git20150507-2) unstable; urgency=medium

  * Ensure idempotent documentation build
    - Use '--archive' flag of 'cp' command to preserve timestamps
    - Patch doc/Makefile and use '-a footer-style=none' flag of 'asciidoc' to
      entirely remove timestamps (Closes: #791856)
  * Patch all Makefiles to accept debhelper's build flags.
    Update previous patch which only fixed build flags for libut.
    This is needed in order to fix dpkg-buildflags-missing build warnings.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Thu, 09 Jul 2015 16:48:57 +0300

uthash (1.9.9.1+git20150507-1) unstable; urgency=low

  * New upstream release (Closes: #748348).
    Import Upstream snapshot from git commit ac47d4928e61.
  * Set myself as maintainer, as discussed with Bastian Blywis.
    Thanks to Bastian Blywis for maintaining uthash!
  * Bump Standards-Version to 3.9.6, no changes needed
  * Bump debhelper compatibility level to 9
  * Update d/patches
    - Drop 'build-doc'/'updateDoc' patches as they are not needed anymore
    - Update 'examples' patch to use DEP-3 format
  * Change package priority to 'optional'
    Don't use 'extra' as uthash-dev doesn't conflict with any other package.
  * Convert manpage from xml to nroff format.
    Don't generate the manpage every time at build phase and remove some of
    the build dependencies.
  * Convert d/copyright to DEP-5 format.
    Update copyright entries.
  * Remove dblatex and libxml2-utils from build dependencies
  * Upstream project has moved to Github
    - Update watch file
    - Update homepage in d/control file
  * Update manpage since upstream doesn't ship doc in PDF
  * Add Vcs-Git and Vcs-Browser fields in d/control
  * Update package's description.
    - Change short description to start with lower case
    - Reformat long description and remove 'Since version 1.9 ...' which
      is more suited for the changelog rather that the description
  * Remove autogenerated d/README.source file
  * Remove redundant d/uthash-dev.dirs file
  * Cleanup d/rules file
  * Patch doc/Makefile and add a 'clean' rule
  * Handle installation of documentation files
  * Install only source code files as examples
  * Run package's test suite
  * Override lintian warning about duplicate files
  * Patch Makefile to accept debhelper's build flags
  * Build 'libut' static library
    - Change package's architecture to 'any'
    - Update manpage
  * Enable multiarch support by setting Multi-Arch to 'same'

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Sat, 04 Jul 2015 19:34:33 +0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Use a temporary build directory.
# We cannot build the documentation in its source directory
# because upstream already includes a compiled version of the
# documentation. Running 'make' will overwrite the files, leaving
# the source directory dirty.
BUILD_DIR=debian/build-dir


%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	# Build 'libut.a' static library
	$(MAKE) -C opt/bundle/src
	# Build documentation (use a temp build directory)
	mkdir -p $(BUILD_DIR)/html
	cp --archive doc/* $(BUILD_DIR)/html/
	$(MAKE) -C $(BUILD_DIR)/html clean
	$(MAKE) -C $(BUILD_DIR)/html

.PHONY: override_dh_installdocs
override_dh_installdocs:
	# Don't install Changelog twice, keep lintian happy
	dh_installdocs --exclude=html/ChangeLog.txt

.PHONY: override_dh_auto_test
override_dh_auto_test:
	# Run uthash testsuite
	$(MAKE) -C tests
	# Run 'libut.a' testsuite
	$(MAKE) -C opt/bundle/tests

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	# Clean 'opt/bundle' build
	$(MAKE) -C opt/bundle clean
	# Clean uthash testsuite
	$(MAKE) -C tests clean
	# Remove temp build directory
	$(RM) -r $(BUILD_DIR)
	# Clean the rest of the files defined in 'd/clean'
	dh_auto_clean

## uthash 1.9.9.1+git20151125

=== libut/Makefile ===
OBJS=libut.a
all: $(OBJS) 
INCDIR=./include
CFLAGS+=-I$(INCDIR)
CFLAGS+=-Wall -Wextra
CFLAGS+=-g

libut.a: libut.o utvector.o utmm.o ringbuf.o
	ar r $@ $^

libut.o: src/libut.c $(INCDIR)/libut.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $<

utvector.o: src/utvector.c $(INCDIR)/utvector.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $<

utmm.o: src/utmm.c $(INCDIR)/utmm.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $<

ringbuf.o: src/ringbuf.c $(INCDIR)/ringbuf.h
	$(CC) $(CFLAGS) -c $<

.PHONY: clean tests install

clean:
	rm -f $(OBJS) *.o
	make -C tests clean

tests: libut.a
	make -C tests 

install: libut.a
	cp $< /usr/local/lib

=== tests/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
         test66 test67 test68 test69 test70 test71 test72 test73 \
         test74 test75 test76 test77 test78 test79 test80 test81 \
         test82 test83 test84 test85
-CFLAGS = -I$(HASHDIR) 
+CFLAGS += -I$(HASHDIR)
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2
 CFLAGS += -g
@@ -81,28 +81,30 @@
 	CC=$(CXX) $(MAKE) all 
 
 example: example.c $(HASHDIR)/uthash.h
-	$(CC) $(CFLAGS) -o $@ $(@).c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
 
 $(PROGS) $(UTILS) : $(HASHDIR)/uthash.h
-	$(CC) $(CFLAGS) -o $@ $(@).c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
 
 hashscan : $(HASHDIR)/uthash.h
-	$(CC) $(CFLAGS) $(MUR_CFLAGS) -o $@ $(@).c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) $(LDFLAGS) -o $@ $(@).c
 
 sleep_test : $(HASHDIR)/uthash.h 
-	$(CC) $(CFLAGS) -DHASH_BLOOM=16 -o $@ $(@).c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_BLOOM=16 $(LDFLAGS) -o $@ $(@).c
 
 $(FUNCS) : $(HASHDIR)/uthash.h
-	$(CC) $(CFLAGS) -DHASH_FUNCTION=HASH_$@ -o keystat.$@ keystat.c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_$@ \
+		$(LDFLAGS) -o keystat.$@ keystat.c
 
 $(SPECIAL_FUNCS) : $(HASHDIR)/uthash.h
-	$(CC) $(CFLAGS) $(MUR_CFLAGS) -DHASH_FUNCTION=HASH_$@ -o keystat.$@ keystat.c 
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) -DHASH_FUNCTION=HASH_$@ \
+		$(LDFLAGS) -o keystat.$@ keystat.c
 
 run_tests: $(PROGS)
 	perl $(TESTS)
 
 run_tests_mingw: $(PROGS)
-	/bin/sh do_tests.mingw
+	/bin/bash do_tests.mingw
 
 astyle:
 	astyle -n --style=kr --indent-switches --add-brackets *.c

=== libut/tests/Makefile ===
PROGS=test1 test2 test3 test4 test5 test6 test7 test8 test9 test10 test11 test12 \
      test13 test14 test15 test16
OBJS=$(patsubst %,%.o,$(PROGS))

CFLAGS += -I../include
CFLAGS += -g
CFLAGS += -Wall -Wextra
LDFLAGS += -L.. -lut

TEST_TARGET=run_tests
TESTS=./do_tests

all: $(OBJS) $(PROGS) $(TEST_TARGET) 

# static pattern rule: multiple targets 

$(OBJS): %.o: %.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $<

$(PROGS): %: %.o
	$(CC) -o $@ $(CPPFLAGS) $(CFLAGS) $< $(LDFLAGS)


run_tests: $(PROGS)
	perl $(TESTS)

.PHONY: clean

clean:	
	rm -f $(PROGS) $(OBJS) test*.out

=== tests/threads/Makefile ===
HASHDIR = ../../src
PROGS = test1 test2

# Thread support requires compiler-specific options
# ----------------------------------------------------------------------------
# GNU 
CFLAGS += -I$(HASHDIR) -g -pthread
# Solaris (Studio 11) 
#CFLAGS = -I$(HASHDIR) -g -mt
# ----------------------------------------------------------------------------

ifeq ($(HASH_DEBUG),1)
CFLAGS += -DHASH_DEBUG=1
endif

all: $(PROGS) run_tests

$(PROGS) : $(HASHDIR)/uthash.h
	$(CC) $(CPPLFAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c

debug:
	$(MAKE) all HASH_DEBUG=1

run_tests: $(PROGS)
	perl ../do_tests

.PHONY: clean

clean:	
	rm -f $(PROGS) test*.out 
	rm -rf test*.dSYM

=== debian/changelog ===
uthash (1.9.9.1+git20151125-1) unstable; urgency=medium

  * New upstream release.
    Import Upstream snapshot from git commit 044474afe5a57.
  * Update d/patches
    - Remove 'Replace-bin-sh-with-bin-bash'
        Applied upstream
    - Remove 'Add-clean-rule-to-remove-autogen-files'
        Applied upstream
    - Update 'Patch-Makefiles-to-honor-CFLAGS-and-CPPFLAGS'
        Partially applied upstream
  * Update d/copyright
  * Remove 'README.Debian' as it is not relevant anymore
  * d/rules: Update build system.
    Upstream has renamed a few folders, so update the d/rules file.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Tue, 29 Dec 2015 18:10:48 +0200

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
https://github.com/troydhanson/uthash/tags .*/v?(\d\S*)\.tar\.gz

## uthash 2.0.1

=== tests/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
         test58 test59 test60 test61 test62 test63 test64 test65 \
         test66 test67 test68 test69 test70 test71 test72 test73 \
         test74 test75 test76 test77 test78 test79 test80 test81 \
-        test82 test83 test84 test85
+        test82 test83 test84 test85 test86 test87
 CFLAGS += -I$(HASHDIR)
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2
@@ -29,7 +29,7 @@
 endif
 
 ifeq ($(HASH_PEDANTIC),1)
-CFLAGS += -pedantic 
+CFLAGS += -pedantic
 endif
 
 TEST_TARGET=run_tests
@@ -71,6 +71,9 @@
 
 tests_only: $(PROGS) $(TEST_TARGET)
 
+GITIGN = .gitignore
+MKGITIGN = [ -f "$(GITIGN)" ] || echo "$(GITIGN)" > $(GITIGN); grep -q '^\$@$$' $(GITIGN) || echo "$@" >> $(GITIGN)
+
 debug:
 	$(MAKE) all HASH_DEBUG=1
 
@@ -85,12 +88,15 @@
 
 $(PROGS) $(UTILS) : $(HASHDIR)/uthash.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
+	@$(MKGITIGN)
 
 hashscan : $(HASHDIR)/uthash.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) $(LDFLAGS) -o $@ $(@).c
+	@$(MKGITIGN)
 
 sleep_test : $(HASHDIR)/uthash.h 
 	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_BLOOM=16 $(LDFLAGS) -o $@ $(@).c
+	@$(MKGITIGN)
 
 $(FUNCS) : $(HASHDIR)/uthash.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_$@ \
@@ -112,5 +118,5 @@
 .PHONY: clean astyle
 
 clean:	
-	rm -f $(UTILS) $(PLAT_UTILS) $(PROGS) test*.out keystat.??? example *.exe
+	rm -f $(UTILS) $(PLAT_UTILS) $(PROGS) test*.out keystat.??? example hashscan sleep_test *.exe $(GITIGN)
 	rm -rf *.dSYM

=== debian/changelog ===
uthash (2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove Patch-Makefiles-to-honor-CFLAGS-and-CPPFLAGS patch.
    Applied upstream.
  * Update d/watch file to use the version 4 format
  * Bump Standards-Version to 3.9.8, no changes needed
  * Update d/copyright file
    - Bump copyright years.
    - Drop obsolete section about removed html files.

 -- Ilias Tsitsimpis <i.tsitsimpis@gmail.com>  Fri, 09 Sep 2016 17:02:22 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ilias Tsitsimpis <i.tsitsimpis@gmail.com>
 Build-Depends: dh-exec (>=0.3), debhelper (>= 9), asciidoc
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://bitbucket.org/iliastsi/uthash
 Vcs-Git: https://bitbucket.org/iliastsi/uthash.git
 Homepage: https://troydhanson.github.io/uthash/

## uthash 2.0.2

=== debian/changelog ===
uthash (2.0.2-1) unstable; urgency=low

  * New upstream release
  * Bump versioned dependency of debhelper (>= 10)
  * Bump debhelper compat level to 10
  * Update my email address
  * Bump Standards-Version to 4.1.1, no changes needed
  * Update d/copyright file (bump Copyright years)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 06 Oct 2017 17:42:53 +0300

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: uthash
 Section: devel
 Priority: optional
-Maintainer: Ilias Tsitsimpis <i.tsitsimpis@gmail.com>
-Build-Depends: dh-exec (>=0.3), debhelper (>= 9), asciidoc
-Standards-Version: 3.9.8
+Maintainer: Ilias Tsitsimpis <iliastsi@debian.org>
+Build-Depends: dh-exec (>=0.3), debhelper (>= 10), asciidoc
+Standards-Version: 4.1.1
 Vcs-Browser: https://bitbucket.org/iliastsi/uthash
 Vcs-Git: https://bitbucket.org/iliastsi/uthash.git
 Homepage: https://troydhanson.github.io/uthash/

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
 	# Build 'libut.a' static library
-	$(MAKE) -C opt/bundle/src
+	$(MAKE) -C libut
 	# Build documentation (use a temp build directory)
 	mkdir -p $(BUILD_DIR)/html
 	cp --archive doc/* $(BUILD_DIR)/html/
@@ -32,15 +32,14 @@
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
-	# Run uthash testsuite
+	# Run both testsuites
 	$(MAKE) -C tests
-	# Run 'libut.a' testsuite
-	$(MAKE) -C opt/bundle/tests
+	$(MAKE) -C libut tests
 
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
-	# Clean 'opt/bundle' build
-	$(MAKE) -C opt/bundle clean
+	# Clean 'libut' directory
+	$(MAKE) -C libut clean
 	# Clean uthash testsuite
 	$(MAKE) -C tests clean
 	# Remove temp build directory

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
https://github.com/troydhanson/@PACKAGE@/tags .*/v?(\d\S*)\.tar\.gz

## uthash 2.1.0

=== tests/Makefile ===
#CC=clang
HASHDIR = ../src
UTILS = emit_keys
PROGS = test1 test2 test3 test4 test5 test6 test7 test8 test9   \
        test10 test11 test12 test13 test14 test15 test16 test17 \
        test18 test19 test20 test21 test22 test23 test24 test25 \
        test26 test27 test28 test29 test30 test31 test32 test33 \
        test34 test35 test36 test37 test38 test39 test40 test41 \
        test42 test43 test44 test45 test46 test47 test48 test49 \
        test50 test51 test52 test53 test54 test55 test56 test57 \
        test58 test59 test60 test61 test62 test63 test64 test65 \
        test66 test67 test68 test69 test70 test71 test72 test73 \
        test74 test75 test76 test77 test78 test79 test80 test81 \
        test82 test83 test84 test85 test86 test87 test88 test89 \
        test90 test91 test92 test93 test94 test95
CFLAGS += -I$(HASHDIR)
#CFLAGS += -DHASH_BLOOM=16
#CFLAGS += -O2
CFLAGS += -g
#CFLAGS += -Wstrict-aliasing=2
CFLAGS += -Wall
#CFLAGS += -Wextra
#CFLAGS += -std=c89
CFLAGS += ${EXTRA_CFLAGS}

ifeq ($(HASH_DEBUG),1)
CFLAGS += -DHASH_DEBUG=1
endif

ifeq ($(HASH_PEDANTIC),1)
CFLAGS += -pedantic
endif

TEST_TARGET=run_tests
TESTS=./do_tests

# These flags are required in order to build with -DHASH_FUNCTION=HASH_MUR.
MUR_CFLAGS = -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing

# detect Cygwin
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "cygwin")),)
  TESTS=./do_tests.cygwin
endif

# detect MinGW
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "mingw")),)
  TEST_TARGET=run_tests_mingw
  TESTS=./do_tests.mingw
endif

#detect Linux (platform specific utilities)
ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "linux")),)
  PLAT_UTILS = hashscan sleep_test
endif

#detect FreeBSD (platform specific utilities)
ifeq ($(strip $(shell uname -s)), FreeBSD)
  ifeq ($(shell if [ `sysctl -n kern.osreldate` -ge 0801000 ]; then echo "ok"; fi), ok)
    PLAT_UTILS = hashscan sleep_test
  endif
endif

all: $(PROGS) $(UTILS) $(PLAT_UTILS) keystat $(TEST_TARGET)

tests_only: $(PROGS) $(TEST_TARGET)

GITIGN = .gitignore
MKGITIGN = [ -f "$(GITIGN)" ] || echo "$(GITIGN)" > $(GITIGN); grep -q '^\$@$$' $(GITIGN) || echo "$@" >> $(GITIGN)

debug:
	$(MAKE) all HASH_DEBUG=1

pedantic:
	$(MAKE) all HASH_PEDANTIC=1

cplusplus:
	CC=$(CXX) $(MAKE) all

thorough:
	$(MAKE) clean && $(MAKE) all EXTRA_CFLAGS='-pedantic'
	$(MAKE) clean && $(MAKE) all EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16'
	$(MAKE) clean && $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16 -DHASH_DEBUG -DNO_DECLTYPE'
	$(MAKE) clean && $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing -DHASH_FUNCTION=HASH_MUR'
	$(MAKE) clean && CC=$(CXX) $(MAKE) all EXTRA_CFLAGS='-pedantic'
	$(MAKE) clean && CC=$(CXX) $(MAKE) all EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16'
	$(MAKE) clean && CC=$(CXX) $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16 -DHASH_DEBUG -DNO_DECLTYPE'
	$(MAKE) clean && CC=$(CXX) $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing -DHASH_FUNCTION=HASH_MUR'

example: example.c $(HASHDIR)/uthash.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c

$(PROGS) $(UTILS) : $(HASHDIR)/uthash.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
	@$(MKGITIGN)

hashscan : $(HASHDIR)/uthash.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) $(LDFLAGS) -o $@ $(@).c
	@$(MKGITIGN)

sleep_test : $(HASHDIR)/uthash.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_BLOOM=16 $(LDFLAGS) -o $@ $(@).c
	@$(MKGITIGN)

keystat : $(HASHDIR)/uthash.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_BER $(LDFLAGS) -o keystat.BER keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_FNV $(LDFLAGS) -o keystat.FNV keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_JEN $(LDFLAGS) -o keystat.JEN keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_OAT $(LDFLAGS) -o keystat.OAT keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_SAX $(LDFLAGS) -o keystat.SAX keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_SFH $(LDFLAGS) -o keystat.SFH keystat.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) -DHASH_FUNCTION=HASH_MUR $(LDFLAGS) -o keystat.MUR keystat.c

run_tests: $(PROGS)
	perl $(TESTS)

run_tests_mingw: $(PROGS)
	/bin/bash do_tests.mingw

astyle:
	astyle -n --style=kr --indent-switches --add-brackets *.c

.PHONY: clean astyle

clean:
	rm -f $(UTILS) $(PLAT_UTILS) $(PROGS) test*.out keystat.??? example hashscan sleep_test *.exe $(GITIGN)
	rm -rf *.dSYM

=== debian/changelog ===
uthash (2.1.0-1) unstable; urgency=medium

  * New upstream release.
    The libut library has been moved into a different repo.
    Update watch file to download both uthash and libut.
  * Update patches to apply cleanly on new upstream
  * Set Rules-Requires-Root to no
  * Update d/copyright file (bump Copyright years)
  * Modify d/copyright to use HTTPS
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.5.0
  * Modify d/rules to build newer version

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 23 Jan 2020 18:51:41 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Ilias Tsitsimpis <iliastsi@debian.org>
-Build-Depends: dh-exec (>=0.3), debhelper (>= 10), asciidoc
-Standards-Version: 4.1.1
+Build-Depends: dh-exec (>=0.3), debhelper (>= 12~), asciidoc
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Vcs-Browser: https://bitbucket.org/iliastsi/uthash
 Vcs-Git: https://bitbucket.org/iliastsi/uthash.git
 Homepage: https://troydhanson.github.io/uthash/

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,9 @@
 
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
+	# Create symlink from libut to uthash
+	ln -s ../ libut/uthash
+	cp libut/Makefile.standalone libut/Makefile
 	# Build 'libut.a' static library
 	$(MAKE) -C libut
 	# Build documentation (use a temp build directory)
@@ -32,17 +35,21 @@
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Run both testsuites
 	$(MAKE) -C tests
 	$(MAKE) -C libut tests
+endif
 
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
 	# Clean 'libut' directory
+	cp libut/Makefile.standalone libut/Makefile
 	$(MAKE) -C libut clean
 	# Clean uthash testsuite
 	$(MAKE) -C tests clean
 	# Remove temp build directory
 	$(RM) -r $(BUILD_DIR)
+	$(RM) libut/uthash libut/Makefile
 	# Clean the rest of the files defined in 'd/clean'
 	dh_auto_clean

## uthash 2.3.0

=== tests/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
         test66 test67 test68 test69 test70 test71 test72 test73 \
         test74 test75 test76 test77 test78 test79 test80 test81 \
         test82 test83 test84 test85 test86 test87 test88 test89 \
-        test90 test91 test92 test93 test94 test95
+        test90 test91 test92 test93 test94 test95 test96
 CFLAGS += -I$(HASHDIR)
 #CFLAGS += -DHASH_BLOOM=16
 #CFLAGS += -O2
@@ -33,9 +33,6 @@
 
 TEST_TARGET=run_tests
 TESTS=./do_tests
-
-# These flags are required in order to build with -DHASH_FUNCTION=HASH_MUR.
-MUR_CFLAGS = -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing
 
 # detect Cygwin
 ifneq ($(strip $(shell $(CC) -v 2>&1 |grep "cygwin")),)
@@ -74,17 +71,15 @@
 	$(MAKE) all HASH_PEDANTIC=1
 
 cplusplus:
-	CC=$(CXX) $(MAKE) all
+	CC="$(CXX) -x c++" $(MAKE) all
 
 thorough:
 	$(MAKE) clean && $(MAKE) all EXTRA_CFLAGS='-pedantic'
 	$(MAKE) clean && $(MAKE) all EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16'
 	$(MAKE) clean && $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16 -DHASH_DEBUG -DNO_DECLTYPE'
-	$(MAKE) clean && $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing -DHASH_FUNCTION=HASH_MUR'
-	$(MAKE) clean && CC=$(CXX) $(MAKE) all EXTRA_CFLAGS='-pedantic'
-	$(MAKE) clean && CC=$(CXX) $(MAKE) all EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16'
-	$(MAKE) clean && CC=$(CXX) $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16 -DHASH_DEBUG -DNO_DECLTYPE'
-	$(MAKE) clean && CC=$(CXX) $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_USING_NO_STRICT_ALIASING -fno-strict-aliasing -DHASH_FUNCTION=HASH_MUR'
+	$(MAKE) clean && CC="$(CXX) -x c++" $(MAKE) all EXTRA_CFLAGS='-pedantic'
+	$(MAKE) clean && CC="$(CXX) -x c++" $(MAKE) all EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16'
+	$(MAKE) clean && CC="$(CXX) -x c++" $(MAKE) tests_only EXTRA_CFLAGS='-pedantic -DHASH_BLOOM=16 -DHASH_DEBUG -DNO_DECLTYPE'
 
 example: example.c $(HASHDIR)/uthash.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
@@ -94,7 +89,7 @@
 	@$(MKGITIGN)
 
 hashscan : $(HASHDIR)/uthash.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) $(LDFLAGS) -o $@ $(@).c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(@).c
 	@$(MKGITIGN)
 
 sleep_test : $(HASHDIR)/uthash.h
@@ -108,7 +103,6 @@
 	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_OAT $(LDFLAGS) -o keystat.OAT keystat.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_SAX $(LDFLAGS) -o keystat.SAX keystat.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -DHASH_FUNCTION=HASH_SFH $(LDFLAGS) -o keystat.SFH keystat.c
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(MUR_CFLAGS) -DHASH_FUNCTION=HASH_MUR $(LDFLAGS) -o keystat.MUR keystat.c
 
 run_tests: $(PROGS)
 	perl $(TESTS)

=== tests/threads/Makefile ===
--- 
+++ 
@@ -3,9 +3,9 @@
 
 # Thread support requires compiler-specific options
 # ----------------------------------------------------------------------------
-# GNU 
+# GNU
 CFLAGS += -I$(HASHDIR) -g -pthread
-# Solaris (Studio 11) 
+# Solaris (Studio 11)
 #CFLAGS = -I$(HASHDIR) -g -mt
 # ----------------------------------------------------------------------------
 
@@ -26,6 +26,6 @@
 
 .PHONY: clean
 
-clean:	
-	rm -f $(PROGS) test*.out 
+clean:
+	rm -f $(PROGS) test*.out
 	rm -rf test*.dSYM

=== debian/changelog ===
uthash (2.3.0-2) unstable; urgency=low

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make. (Closes: #1059718)

  [ Ilias Tsitsimpis ]
  * Bump Standards-Version to 4.6.2

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 02 Jan 2024 09:35:10 +0200

uthash (2.3.0-1) unstable; urgency=medium

  * New upstream release
  * Update d/copyright file (bump Copyright years)
  * Use the debhelper-compat build-dependency and remove d/compat
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.6.0

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 11 Sep 2021 17:02:52 +0300

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,12 @@
 Section: devel
 Priority: optional
 Maintainer: Ilias Tsitsimpis <iliastsi@debian.org>
-Build-Depends: dh-exec (>=0.3), debhelper (>= 12~), asciidoc
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-exec (>=0.3),
+ asciidoc
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://bitbucket.org/iliastsi/uthash
 Vcs-Git: https://bitbucket.org/iliastsi/uthash.git
 Homepage: https://troydhanson.github.io/uthash/

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	ln -s ../ libut/uthash
 	cp libut/Makefile.standalone libut/Makefile
 	# Build 'libut.a' static library
-	$(MAKE) -C libut
+	dh_auto_build --sourcedirectory libut
 	# Build documentation (use a temp build directory)
 	mkdir -p $(BUILD_DIR)/html
 	cp --archive doc/* $(BUILD_DIR)/html/
@@ -50,6 +50,6 @@
 	$(MAKE) -C tests clean
 	# Remove temp build directory
 	$(RM) -r $(BUILD_DIR)
-	$(RM) libut/uthash libut/Makefile
+	$(RM) -r libut/uthash libut/Makefile
 	# Clean the rest of the files defined in 'd/clean'
 	dh_auto_clean
